from wxPython.wx import *

class lsListCtrl(wxPanel):
    """ Base class for list controls used in wxLoadSite """
    def __init__(self, parent, lID):
        wxPanel.__init__(self, parent, lID)
        nID = NewId()
        self.SetAutoLayout(TRUE) 
        self._listCtrl = wxListCtrl(self, nID, wxDefaultPosition, wxDefaultSize, 
                            wxLC_REPORT | wxSUNKEN_BORDER)
        pc = wxLayoutConstraints()
        pc.top.SameAs(self, wxTop, 20)
        pc.left.SameAs(self, wxLeft, 0)
        pc.bottom.SameAs(self, wxBottom, 0)
        pc.right.SameAs(self, wxRight, 0)
        self._listCtrl.SetConstraints(pc)
                
                                                                   
        self.parentwindow = parent
        self.selectedItems = []
        
        self.images=wxImageList(15, 16)
        wxImage_AddHandler(wxPNGHandler())
        self.images.Add(wxImage('wxLoadSite/images/folder.png', wxBITMAP_TYPE_PNG).ConvertToBitmap())
        self.images.Add(wxImage('wxLoadSite/images/doc.png', wxBITMAP_TYPE_PNG).ConvertToBitmap())
        self._listCtrl.SetImageList(self.images, wxIMAGE_LIST_SMALL)
        
        EVT_LEFT_DCLICK(self._listCtrl, self.onDoubleClick)
        EVT_LIST_ITEM_SELECTED(self._listCtrl, nID, self.onItemSelected)
        EVT_LIST_ITEM_DESELECTED(self._listCtrl, nID, self.onItemDeselected)

    def updateList(self):
        """ refresh list contents """
        self.selectedItems = []
    
    def onItemSelected(self, event):
        self.currentItem = event.m_itemIndex
        self.selectedItems.append(event.m_itemIndex)
        
    def onItemDeselected(self, event):
        self.selectedItems.remove(event.m_itemIndex)
            
    def onDoubleClick(self, event):
        dirChanged = self.changedir(self._listCtrl.GetItemText(self.currentItem))
        if dirChanged:            
            self.updateList()
    
    def changedir(self, dirname):
        raise NotImplemented
    
    # Wrappers for wxListCtrl functions
    # Note to self - read about __getattr__
    # ----------------------------------
    def InsertColumn(self, id, name):
        self._listCtrl.InsertColumn(id, name)
        
    def DeleteAllItems(self):
        self._listCtrl.DeleteAllItems()
        
    def InsertItem(self, item):
        return self._listCtrl.InsertItem(item)
        
    def SetStringItem(self, index, col, label, imageId=-1):
        self._listCtrl.SetStringItem(index, col, label, imageId)
            
    def SetItemText(self, item, text):
        self._listCtrl.SetItemText(item, text)
        
    def EnsureVisible(self, item):
        self._listCtrl.EnsureVisible(item)

    def GetItemText(self, item):
        return self._listCtrl.GetItemText(item)
